---
title: sourceCapabilities
slug: Web/API/UIEvent/sourceCapabilities
tags:
  - API
  - DOM
  - Property
  - Reference
  - UIEvent
---
<p>{{SeeCompatTable}}{{APIRef()}}</p>

<p>The <strong><code>UIEvent.sourceCapabilities</code></strong> read-only property returns an instance of the {{domxref('InputDeviceCapabilities')}} interface which provides information about the physical device responsible for generating a touch event. If no input device was responsible for the event, it returns <code>null</code>.</p>

<p>When a single user interaction with an input device generates a series of different input events, the <code>sourceCapabilities</code> property for all of them will point to the same instance of <code>InputDeviceCapabilities</code>. For example, when a user lifts their finger off of a touchscreen, several UIEvents may be generated including <code>touchend</code>, <code>mousedown</code>, <code>click</code>, and <code>focus</code>. All of these events must have the same <code>sourceCapabilities</code> representing the touchscreen.</p>

<p>A device is considered "responsible" for an event only when that interaction is part of the abstraction provided by the web platform. For example, many user agents allow a window to be resized with a mouse or a keyboard, but this detail is not exposed to the web platform in any way, and so the sourceCapabilities of a resize event will typically be null.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><code>var iDC = event.sourceCapabilities</code></pre>

<h3 id="Value">Value</h3>

<p>An instance of {{domxref('InputDeviceCapabilities')}}.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th>Specification</th>
   <th>Status</th>
   <th>Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('InputDeviceCapabilities','#dom-uievent-sourcecapabilities','sourceCapabilities')}}</td>
   <td>{{Spec2('InputDeviceCapabilities')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.UIEvent.sourceCapabilities")}}</p>
